#include<iostream>
using namespace std;
int main(){
	int s=0;
	int n,k;
	cin>>n>>k;
	int niz[n];
	for(int i=0;i<n;i++){
		cin>>niz[i];
		s+=niz[i];
	}
	if(k==0){
		cout<<s;
		return 0;
	}
	long long r=0,rdt=0;
	//za k je 1
	for(int i=0;i<n;i++){
		rdt=niz[i];
		r+=niz[i];
		for(int j=i+1;j<n;j++){
			r=r+niz[j]+rdt;
			rdt+=niz[j];
		}
	}
	cout<<r%1000000007<<endl;
	return 0;
}